#include <bits/stdc++.h>

using namespace std;
int n,m,viz[150][150];
int vizEnd[150][150];
int inQueue[150][150];
char s[150];
vector <pair<int,int>> poz;
vector <pair<int,int>> endpoz;
pair <int,int> start;

int dx[]={1,-1,0,0};
int dy[]={0,0,-1,1};
int distEnd[150][150],vizStart[150][150],vizCurrent[150][150];
bool insideNM (pair <int,int> acum)
{
    // aici verific si daca pot ajunge acolo
    if (1<=acum.first && acum.first <=n && 1<=acum.second && acum.second <=m && viz[acum.first][acum.second] != -1)
        return true;
    return false;
}
set <pair<int,int>> currentPositions;

vector <pair <int,int>> neighbours(pair <int,int> acum)
{
    vector <pair<int,int>> answer;
    for (int i=0;i<4;i++)
    {
        pair <int,int> neighbour = {acum.first+dx[i],acum.second+dy[i]};
        if (insideNM(neighbour)==true && vizCurrent[neighbour.first][neighbour.second] == 0 && distEnd[neighbour.first][neighbour.second]>=0)
            answer.push_back(neighbour);
    }
    return answer;
}
vector <pair <int,int>> neighboursLigma(pair <int,int> acum)
{
    vector <pair<int,int>> answer;
    for (int i=0;i<4;i++)
    {
        pair <int,int> neighbour = {acum.first+dx[i],acum.second+dy[i]};
        if (insideNM(neighbour)==true && vizCurrent[neighbour.first][neighbour.second] == 1 && distEnd[neighbour.first][neighbour.second]>=0)
            answer.push_back(neighbour);
    }
    return answer;
}
int vizHello[150][150];
bool wouldntDisc(pair <int,int> currentCell)
{
    pair<int,int> start;
    vector<pair<int,int>>  neighboursNow = neighboursLigma(currentCell);
    for (int i=0;i<neighboursNow.size();i++)
    {
        if (vizCurrent[neighboursNow[i].first][neighboursNow[i].second] == 1)
        {
            start = neighboursNow[i];
            break;
        }
    }
    vizCurrent[currentCell.first][currentCell.second]=0;
    for (int i=1;i<=n;i++)
    {
        for (int j=1;j<=m;j++)
        {
            vizHello[i][j]=0;
        }
    }
    queue <pair <int,int>> q;
    q.push(start);
    int nr=1;
    while (!q.empty())
    {
        auto acum = q.front();
        q.pop();
        vector<pair<int,int>>  neighboursNow = neighboursLigma(acum);
        for (int i=0;i<neighboursNow.size();i++)
        {
            auto a = neighboursNow[i];
            if (vizHello[a.first][a.second]==0 && vizCurrent[a.first][a.second]==1)
            {
                q.push(a);
                vizHello[a.first][a.second]=1;
                nr++;
            }
        }
    }
    vizCurrent[currentCell.first][currentCell.second]=1;
    return nr==poz.size();
}
int main() {
    ios_base :: sync_with_stdio(false);

    cin.tie(0);

    cin >> n>>m;
    cin.get();

    for (int i=1;i<=n;i++)
    {
        cin.getline(s,m+5);
        for (int k=0;k<m;k++)
        {
            if (s[k]=='*')
            {
                poz.push_back({i,k+1});
            }
            if (s[k]=='X')
            {
                viz[i][k+1]=-1;
            }
        }
    }

    cin.getline(s,m+5);
    for (int i=1;i<=n;i++)
    {
        cin.getline(s,m+5);
        for (int k=0;k<m;k++)
        {
            if (s[k]=='*')
            {
                start = {i,k+1};
                endpoz.push_back({i,k+1});
            }
        }
    }

    queue <pair<int,int> > q;
    q.push(start);
    for (int i=1;i<=n;i++)
    {
        for (int j=1;j<=m;j++)
        {
            vizEnd[i][j]=0;
            inQueue[i][j]=0;
        }
    }
    vizEnd[start.first][start.second]=1;
    while (!q.empty())
    {
        pair<int,int> acum = q.front();
        q.pop();
        inQueue[acum.first][acum.second]=0;
        for (int i=0;i<4;i++)
        {
            pair <int,int> vecin ={acum.first+dx[i],acum.second+dy[i]};
            if (insideNM(vecin) == true && vizEnd[vecin.first][vecin.second] == 0 && inQueue[vecin.first][vecin.second] == 0)
            {
                vizEnd[vecin.first][vecin.second]=1;
                inQueue[vecin.first][vecin.second]=1;
                q.push(vecin);
            }
        }
    }
    for (int i=1;i<=n;i++)
    {
        for (int j=1;j<=m;j++)
        {
            distEnd[i][j]=-1;
            inQueue[i][j]=0;
        }
    }
    for (int i=0;i<endpoz.size();i++)
    {
        q.push(endpoz[i]);
        distEnd[endpoz[i].first][endpoz[i].second]=0;
    }

    while (!q.empty())
    {
        pair<int,int> acum = q.front();
        q.pop();
        inQueue[acum.first][acum.second]=0;
        for (int i=0;i<4;i++)
        {
            pair <int,int> vecin ={acum.first+dx[i],acum.second+dy[i]};
            if (insideNM(vecin) == true && inQueue[vecin.first][vecin.second] == 0 && (distEnd[vecin.first][vecin.second] == -1 || distEnd[vecin.first][vecin.second] > distEnd[acum.first][acum.second]+1 ))
            {
                distEnd[vecin.first][vecin.second] = distEnd[acum.first][acum.second]+1;
                inQueue[vecin.first][vecin.second]=1;
                q.push(vecin);
            }
        }
    }

    while (!q.empty())
        q.pop();

    for (int i=0;i<poz.size();i++)
    {
        q.push(poz[i]);
    }

    for (int i=1;i<=n;i++)
    {
        for (int j=1;j<=m;j++)
        {
            vizStart[i][j]=0;
            inQueue[i][j]=0;
        }
    }

    while (!q.empty())
    {
        pair<int,int> acum = q.front();
        q.pop();
        inQueue[acum.first][acum.second]=0;
        for (int i=0;i<4;i++)
        {
            pair <int,int> vecin ={acum.first+dx[i],acum.second+dy[i]};
            if (insideNM(vecin) == true && vizStart[vecin.first][vecin.second] == 0 && inQueue[vecin.first][vecin.second] == 0)
            {
                vizStart[vecin.first][vecin.second]=1;
                inQueue[vecin.first][vecin.second]=1;
                q.push(vecin);
            }
        }
    }

    for (int i=0;i<endpoz.size();i++)
    {
        if (vizStart[endpoz[i].first][endpoz[i].second] == 0)
        {
            cout<<"NO";
            return 0;
        }
    }
    priority_queue < pair <int,pair<int,int>> , vector <pair<int,pair<int,int>>> , greater<pair<int,pair<int,int> > > > heapie;
    priority_queue <pair<int,pair <int,int>>> heapie2;
    for (int i=1;i<=n;i++)
    {
        for (int j=1;j<=m;j++)
        {
            viz[i][j]=0;
        }
    }
    int nrLeft = endpoz.size();
    for (int i=0;i<poz.size();i++)
    {
        vizCurrent[poz[i].first][poz[i].second]=1;
        if (distEnd[poz[i].first][poz[i].second] == 0)
        {
            nrLeft--;
        }
    }
    for (int i=0;i<poz.size();i++)
    {
        currentPositions.insert(poz[i]);
        vector <pair<int,int>> neighboursNow = neighbours(poz[i]);
        heapie2.push({distEnd[poz[i].first][poz[i].second],poz[i]});
        for (int j=0;j<neighboursNow.size();j++)
        {
            if (viz[neighboursNow[j].first][neighboursNow[j].second] ==0)
            {
                heapie.push({distEnd[neighboursNow[j].first][neighboursNow[j].second],{neighboursNow[j]}});
            }
            viz[neighboursNow[j].first][neighboursNow[j].second]++;
        }
    }
    vector<pair <pair<int,int>,pair<int,int>>> answer;
    // That means I have not covered the final positions
    // Otherwise all neighbours would have distance 1
    while (!heapie.empty() && nrLeft>0)
    {
        while (!heapie.empty() && (viz[heapie.top().second.first][heapie.top().second.second] == 0 || vizCurrent[heapie.top().second.first][heapie.top().second.second] == 1))
        {
            heapie.pop();
        }
        if (heapie.empty())
            break;
        pair <int,int> currentCell = heapie.top().second;
        vector <pair<int,int>> gotOut;
        if (poz.size()!=2)
        {
            while (!heapie2.empty() && wouldntDisc(heapie2.top().second) == false)
            {
                gotOut.push_back(heapie2.top().second);
                heapie2.pop();
            }
        }
        if (heapie2.empty())
            break;
        pair<int,int> farthestAway = heapie2.top().second;
        heapie2.pop();
        for (int i=0;i<gotOut.size();i++)
        {
            heapie2.push({distEnd[gotOut[i].first][gotOut[i].second],gotOut[i]});
        }
        heapie.pop();
        answer.push_back({farthestAway,currentCell});
        vector <pair<int,int>> neighboursNow = neighbours(farthestAway);
        for (int j=0;j<neighboursNow.size();j++)
        {
            viz[neighboursNow[j].first][neighboursNow[j].second]--;
        }
        neighboursNow = neighbours(currentCell);

        for (int j=0;j<neighboursNow.size();j++)
        {
            if (viz[neighboursNow[j].first][neighboursNow[j].second] ==0)
            {
                heapie.push({distEnd[neighboursNow[j].first][neighboursNow[j].second],{neighboursNow[j]}});
            }
            viz[neighboursNow[j].first][neighboursNow[j].second]++;
        }
        heapie2.push({distEnd[currentCell.first][currentCell.second],currentCell});
        vizCurrent[farthestAway.first][farthestAway.second]=0;
        vizCurrent[currentCell.first][currentCell.second]=1;
        if (distEnd[currentCell.first][currentCell.second]==0)
            nrLeft--;
    }
    if (nrLeft !=0)
    {
        cout<<"NO";
        return 0;
    }
    cout<<"YES"<<'\n';
    assert(answer.size()<=10000);
    cout<<answer.size()<<'\n';
    for (int i=0;i<answer.size();i++)
    {
        cout<<answer[i].first.first<<" "<<answer[i].first.second<<" "<<answer[i].second.first<<" "<<answer[i].second.second<<'\n';
    }
    return 0;
}

/**
3 5
*....
**X..
XXX..

.....
..X.*
XXX**




5 8
.******.
**.X**..
*******.
**.X**..
.*******

.******.
...X****
.*******
...X****
.*******

50 50
***...............................................
***X..............................................
***X..............................................
XXXX..............................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................

..................................................
...X..............................................
...X..............................................
XXXX..............................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
..................................................
...............................................***
...............................................***
...............................................***

*/